<?php
/******************************************
* File      :   functions.modrewrite.php
* Project   :   Contenido
* Descr     :   Defines the 'modrewrite' related
*               functions
*
* Author    :   Stefan Seifarth
* Created   :   04.12.2004
* Modified  :   18.12.2005
*
* � www.polycoder.de
******************************************/

/**
* mr_get_language_id()
*
* get language id from language name
* thanks to Nicolas Dickinson for multi 
* Client/Language BugFix
*
* @param	string	language name
* @return integer	language id
*/
function mr_get_language_id ( $str_languagename = "", $int_client = 1 ) {
	global $cfg;
	
	$int_lang_id = false;
	$db = new DB_Contenido;

	$sql = "SELECT l.idlang
           FROM " . $cfg["tab"]["lang"] . " as l 
           LEFT JOIN " . $cfg["tab"]["clients_lang"] . " AS cl ON l.idlang = cl.idlang
           WHERE
              cl.idclient = '". (int)$int_client . "' AND 
              l.name = '" . urldecode($str_languagename) . "'";

	$db->query($sql);
	$db->next_record();
		
	if ($db->f('idlang') > 0) {
		$int_lang_id = $db->f('idlang');
	}

	return $int_lang_id;
}




/**
* mr_get_client_id()
*
* get client id from client name
*
* @param	  string    client name
* @return  integer   client id
*/
function mr_get_client_id ( $str_clientname = "" ) {
	global $cfg;
	
	$int_client_id = false;
	$db = new DB_Contenido;

	$sql = "SELECT idclient 
			FROM " . $cfg["tab"]["clients"] . "
			WHERE name = '" . urldecode($str_clientname) . "'";
	$db->query($sql);
	$db->next_record();
		
	if ($db->f('idclient') > 0) {
		$int_client_id = $db->f('idclient');
	}

	return $int_client_id;
}


/**
* mr_get_idart()
*
* get article id
*
* get recent article from websafe name tree
*
* @modified: 2005-09-11
* @param	string	Websafe name
* @param	integer	category id
* @return 	integer	recent article id
*/
function mr_get_idart ( $str_artname = "", $int_id = 0, $int_lang_id = 0 ) {
	global $cfg;
	
	$int_idart = false;
	
	$db = new DB_Contenido;

    
    
	$str_where = "";
    // only article name were given
    if ($int_id == 0) {
        // get all basic category ids with parentid=0
        $sql = "SELECT idcat FROM " . $cfg["tab"]["cat"] . " WHERE parentid = '0'";
        $db->query ( $sql );
        
        $arr_idcats = array();
        $arr_where = array();
        
        while ($db->next_record()) {
            $arr_idcats[] = "idcat = '" . $db->f("idcat") . "'";
        }
        $str_where = " AND ( " . join(" OR ", $arr_idcats) . ")";
    } else {
        $str_where = " AND ca.idcat = '$int_id'";
    }
    
	$sql = "SELECT al.idart 
			FROM " . $cfg["tab"]["art_lang"] . " al 
			LEFT JOIN " . $cfg["tab"]["cat_art"] . " ca 
			ON al.idart = ca.idart 
			WHERE al.urlname = '$str_artname'" . $str_where;
            
	$db->query($sql);
	$db->next_record();
	
	if ($db->f('idart') > 0) {
		$int_idart = $db->f('idart');
	}
	
	return $int_idart;
}



/**
* mr_get_setting_override()
*
* override local cfg settings with client settings from database
*
* @param	integer	client id
*/
function mr_get_setting_override ( $int_client_id ) {
   global $cfg;

   $db = new DB_Contenido();
   
   $sql = "SELECT name, value FROM " . $cfg["tab"]["properties"] . " WHERE type='ModRewrite' AND idclient = '" . $int_client_id . "' AND name NOT LIKE 'frontend_path%'";
   $db->query($sql);
   
   while ( $db->next_record() ) {
      $cfg['mod_rewrite'][urldecode($db->f("name"))] = urldecode($db->f("value"));
   }
}

?>
