<?php
/******************************************
* File      :   functions.stat.php
* Project   :   Contenido
* Descr     :   Defines the 'stat' related
*               functions
*
* Author    :   Olaf Niemann
* Created   :   02.03.2002
* Modified  :   28.04.2003
*
*  four for business AG
*****************************************/



function statsDisplayInfo($id, $type, $x, $y, $w, $h)
{
    if (strcmp($type,"article" == 0))
    {
        $text = i18n("Info about article")." ". $id;
    } else {
        $text = i18n("Info about directory") ." ". $id;
    }
    
    $div = '<DIV ID="idElement14" class="text_medium" style="background: #E8E8EE;
             border: 1px; border-style: solid; border-color: #747488; position:absolute;
             top:'.$x.'px; left:'.$y.'.px; width:'.$w.'px; height:'.$h.'px;">'.$text.'</DIV>';

    return $div;
}

/**
 * Archives the current statistics
 *
 * @param $yearmonth String with the desired archive date (YYYYMM)
 *
 * @return none
 *
 */
function statsArchive($yearmonth)
{
    global $cfg;

    $yearmonth = ereg_replace (" ", "0", $yearmonth);

	$db = new DB_Contenido;
    $db2 = new DB_Contenido;
	
    $sql = "SELECT
                idcatart, idlang, idclient, visited, visitdate
            FROM
                ".$cfg["tab"]["stat"];

    $db->query($sql);

    while ($db->next_record())
    {
        $insertSQL = "INSERT INTO
                          ".$cfg["tab"]["stat_archive"]."
                          ( idstatarch, archived, idcatart, idlang, idclient, visited, visitdate)
                      VALUES
                          (".$db2->nextid($cfg["tab"]["stat_archive"]).",
                           ".$yearmonth.",
                           ".$db->f(0).",
                           ".$db->f(1).",
                           ".$db->f(2).",
                           ".$db->f(3).",
                           '".$db->f(4)."')";

        $db2->query($insertSQL);
    }

    $sql = "DELETE FROM ".$cfg["tab"]["stat"];
    $db->query($sql);

    // Recreate empty stats
    $sql = "SELECT
                A.idcatart,
                B.idclient,
                C.idlang
            FROM
                ".$cfg["tab"]["cat_art"]." AS A INNER JOIN
                ".$cfg["tab"]["cat"]." AS B ON A.idcat = B.idcat INNER JOIN
                ".$cfg["tab"]["cat_lang"]." AS C ON A.idcat = C.idcat ";

    $db->query($sql);

    while ($db->next_record())
    {
        $insertSQL = "INSERT INTO
                          ".$cfg["tab"]["stat"]."
                          ( idstat, idcatart, idlang, idclient, visited )
                      VALUES (
                          ".$db2->nextid($cfg["tab"]["stat"]).",
                          ".$db->f(0).",
                          ".$db->f(2).",
                          ".$db->f(1).",
                          '0000-00-00 00:00:00')";

        $db2->query($insertSQL);
    }
} 


/**
 * Generates a statistics page
 *
 * @param $yearmonth  Specifies the year and month from which to retrieve the
 *                    statistics, specify "current" to retrieve the current
 *                    entries
 * @author Jan Lengowski <Jan.Lengowski@4fb.de>
 * @modified Timo A. Hummel <Timo.Hummel@4fb.de>
 * @copyright four for business AG <http://www.4fb.de>
 *
 * @return none
 *
 */
function statsOverviewAll($yearmonth)
{
	global $cfg, $db, $tpl, $client, $lang;

	$sql = "SELECT
                    idtree, A.idcat, level, preid, C.name, visible
                FROM
                    ".$cfg["tab"]["cat_tree"]." AS A,
                    ".$cfg["tab"]["cat"]." AS B,
                    ".$cfg["tab"]["cat_lang"]." AS C
                WHERE
                    A.idcat=B.idcat
                AND
                    B.idcat=C.idcat
                AND
                    C.idlang='$lang'
                AND
                    B.idclient='$client'
                ORDER BY
                    idtree";

    $db->query($sql);

    $currentRow = 2;
    
    while ($db->next_record()) {
        if ($db->f("level") == 0 && $db->f("preid") != 0) {
            $bgcolor = '#FFFFFF';
            $tpl->set('d', 'BGCOLOR', $bgcolor);
            $tpl->set('d', 'PADDING_LEFT', '10');
            $tpl->set('d', 'TEXT', '&nbsp;');
            $tpl->set('d', 'NUMBEROFARTICLES', '');
            $tpl->set('d', 'TOTAL', '');
            $tpl->set('d', 'ICON','');
            $tpl->set('d', 'STATUS', '');
            $tpl->set('d', 'BORDERCOLOR', $cfg["color"]["table_border"]);
            $tpl->set('d', 'INTHISLANGUAGE', '');
            $tpl->next();
            $currentRow++;
    	}

    	$padding_left	= 10 + ( 15 * $db->f("level") );
        $text			= $db->f(4);
        $idcat			= $db->f("idcat");

        $db2 = new DB_Contenido;
        //************** number of arts **************
        $sql = "SELECT COUNT(*) FROM ".$cfg["tab"]["cat_art"]." WHERE idcat='$idcat'";
        $db2->query($sql);
        $db2->next_record();

        $numberOfArticles = $db2->f(0);
		$sumNumberOfArticles += $numberOfArticles;
        //************** hits of category total**************
        if (strcmp($yearmonth,"current") == 0)
        {
            $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat"]." AS B WHERE A.idcatart=B.idcatart AND A.idcat='$idcat' AND B.idclient='$client'";
        } else {
            $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat_archive"]." AS B WHERE A.idcatart=B.idcatart AND A.idcat='$idcat' AND B.idclient='$client' AND B.archived = ".$yearmonth;
        }
        $db2->query($sql);
        $db2->next_record();

        $total = $db2->f(0);

        //************** hits of category in this language ***************
        if (strcmp($yearmonth,"current") == 0)
        {
            $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat"]." AS B WHERE A.idcatart=B.idcatart AND A.idcat='$idcat' AND B.idlang='$lang' AND B.idclient='$client'";
        } else {
            $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat_archive"]." AS B WHERE A.idcatart=B.idcatart AND A.idcat='$idcat' AND B.idlang='$lang' AND B.idclient='$client' AND B.archived = ".$yearmonth;
        }

        $db2->query($sql);
        $db2->next_record();

        $inThisLanguage = $db2->f(0);

        $icon = '<img src="'.$cfg['path']['images'].'folder.gif">';

        //************ art ********************************
        $sql = "SELECT * FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["art"]." AS B, ".$cfg["tab"]["art_lang"]." AS C WHERE A.idcat='$idcat' AND A.idart=B.idart AND B.idart=C.idart AND C.idlang='$lang' ORDER BY B.idart";
        $db2->query($sql);
        
        $numrows = $db2->num_rows();
        $onclick = "";
        
        $online = $db->f("visible");
        if ($online == 1)
        {
            $offonline = '<img src="'.$cfg['path']['images'].'online.gif" alt="'.i18n("Category is online").'" title="'.i18n("Category is online").'">';
        } else {
            $offonline = '<img src="'.$cfg['path']['images'].'offline.gif" alt="'.i18n("Category is offline").'" title="'.i18n("Category is offline").'">';
        }
        
        $bgcolor = $cfg["color"]["table_dark"];
        $tpl->set('d', 'BGCOLOR', $bgcolor);
        $tpl->set('d', 'PADDING_LEFT', $padding_left);
        $tpl->set('d', 'TEXT', $text);
        $tpl->set('d', 'ONCLICK', $onclick);
        $tpl->set('d', 'ICON', $icon);
        $tpl->set('d', 'STATUS', $offonline);
        $tpl->set('d', 'NUMBEROFARTICLES', $numberOfArticles);
        $tpl->set('d', 'TOTAL', $total);
        $tpl->set('d', 'ROWNAME', "HIDE".$db->f("level"));
        $tpl->set('d', 'BORDERCOLOR', $cfg["color"]["table_border"]);
        $tpl->set('d', 'INTHISLANGUAGE', $inThisLanguage);
        $tpl->next();
        $currentRow++;
        
        $onclick = "";

        $text             = "";
        $numberOfArticles = "";
        $total            = "";
        $inThisLanguage   = "";

        while ($db2->next_record()) {
            $idart = $db2->f("idart");

            $text             = "";
            $numberOfArticles = "";
            $total            = "";
            $inThisLanguage   = "";

    	    $padding_left = 10 + ( 15 * ($db->f("level")+1) );

            $text = $db2->f("title");
            $online = $db2->f("online");

            //************** number of arts **************
          	$db3 = new DB_contenido;

           	//************** hits of art total **************
           	if (strcmp($yearmonth,"current") == 0)
           	{
                $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat"]." AS B WHERE A.idcatart=B.idcatart AND A.idcat='$idcat' AND A.idart='$idart' AND B.idclient='$client'";
            } else {
                $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat_archive"]." AS B WHERE A.idcatart=B.idcatart AND A.idcat='$idcat' AND A.idart='$idart' AND B.idclient='$client' and B.archived = ".$yearmonth;
            }
            $db3->query($sql);
            $db3->next_record();

            $total = $db3->f(0);

            //************** hits of art in this language ***************
            if (strcmp($yearmonth,"current") == 0)
           	{
          	     $sql = "SELECT visited FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat"]." AS B WHERE A.idcatart=B.idcatart AND A.idcat='$idcat' AND A.idart='$idart' AND B.idlang='$lang' AND B.idclient='$client'";
          	} else {
          	     $sql = "SELECT visited FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat_archive"]." AS B WHERE A.idcatart=B.idcatart AND A.idcat='$idcat' AND A.idart='$idart' AND B.idlang='$lang' AND B.idclient='$client' AND B.archived = ".$yearmonth;
          	}
            $db3->query($sql);
            $db3->next_record();

            $inThisLanguage = $db3->f(0);

            if ($online == 0) {
                $offonline = '<img src="'.$cfg['path']['images'].'offline.gif" alt="Artikel ist offline" title="Artikel ist offline">';
            } else {
                $offonline = '<img src="'.$cfg['path']['images'].'online.gif" alt="Artikel ist online" title="Artikel ist online">';
            }

            $icon = '<img src="'.$cfg['path']['images'].'article.gif">';
            $bgcolor = $cfg["color"]["table_light"];
            $tpl->set('d', 'BGCOLOR', $bgcolor);
            $tpl->set('d', 'PADDING_LEFT', $padding_left);
            $tpl->set('d', 'TEXT', $text);
            $tpl->set('d', 'ONCLICK', "");
            $tpl->set('d', 'ICON', $icon);
            $tpl->set('d', 'STATUS', $offonline);
            $tpl->set('d', 'ROWNAME', "HIDE".($db->f("level")+1));
            $tpl->set('d', 'NUMBEROFARTICLES', $numberOfArticles);
            $tpl->set('d', 'TOTAL', $total);
            $tpl->set('d', 'BORDERCOLOR', $cfg["color"]["table_border"]);
            $tpl->set('d', 'INTHISLANGUAGE', $inThisLanguage);
            $tpl->next();
            $currentRow++;

        }
    }

    //************** hits total**************
    if (strcmp($yearmonth,"current") == 0)
    {
        $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat"]." AS B WHERE A.idcatart=B.idcatart AND B.idclient='$client'";
    } else {
       $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat_archive"]." AS B WHERE A.idcatart=B.idcatart AND B.idclient='$client' AND B.archived = ".$yearmonth;
    }
    //$sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["stat"]." WHERE idclient='$client'";
    $db->query($sql);
    $db->next_record();

    $total = $db->f(0);

    //************** hits total on this language ***************
    if (strcmp($yearmonth,"current") == 0)
    {
        $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat"]." AS B WHERE A.idcatart=B.idcatart AND B.idlang='$lang' AND B.idclient='$client'";
    } else {
        $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat_archive"]." AS B WHERE A.idcatart=B.idcatart AND B.idlang='$lang' AND B.idclient='$client' AND B.archived = ".$yearmonth;
    }
    $db->query($sql);
    $db->next_record();

    $inThisLanguage = $db->f(0);
    
    $bgcolor = '#FFFFFF';
    $tpl->set('d', 'BGCOLOR', $bgcolor);
    $tpl->set('d', 'BORDERCOLOR', $cfg["color"]["table_border"]);
    $tpl->set('d', 'TEXT', '&nbsp;');
    $tpl->set('d', 'ICON', '');
    $tpl->set('d', 'STATUS', '');
    $tpl->set('d', 'PADDING_LEFT', '10');
    $tpl->set('d', 'NUMBEROFARTICLES', '');
    $tpl->set('d', 'TOTAL', '');
    $tpl->set('d', 'INTHISLANGUAGE', '');

    $bgcolor = $cfg["color"]["table_dark"];
    $tpl->set('s', 'SUMBGCOLOR', $cfg["color"]["table_dark"]);
    $tpl->set('s', 'SUMTEXT', i18n("Sum"));
    $tpl->set('s', 'SUMNUMBEROFARTICLES', $sumNumberOfArticles);
    $tpl->set('s', 'SUMTOTAL', $total);
    $tpl->set('s', 'SUMINTHISLANGUAGE', $inThisLanguage);
    $tpl->next();
}

/**
 * Generates a statistics page for a given year
 *
 * @param $year       Specifies the year to retrieve the
 *                    statistics for
 * @author Jan Lengowski <Jan.Lengowski@4fb.de>
 * @modified Timo A. Hummel <Timo.Hummel@4fb.de>
 * @copyright four for business AG <http://www.4fb.de>
 *
 * @return none
 *
 */
function statsOverviewYear($year)
{
    global $cfg, $db, $tpl, $client, $lang;

    $sql = "SELECT
                    idtree, A.idcat, level, preid, C.name
                FROM
                    ".$cfg["tab"]["cat_tree"]." AS A,
                    ".$cfg["tab"]["cat"]." AS B,
                    ".$cfg["tab"]["cat_lang"]." AS C
                WHERE
                    A.idcat=B.idcat
                AND
                    B.idcat=C.idcat
                AND
                    C.idlang='$lang'
                AND
                    B.idclient='$client'
                ORDER BY
                    idtree";

    $db->query($sql);

    $currentRow = 2;

    while ($db->next_record()) {
        if ($db->f("level") == 0 && $db->f("preid") != 0) {
            $bgcolor = '#FFFFFF';
            $tpl->set('d', 'BGCOLOR', $bgcolor);
            $tpl->set('d', 'PADDING_LEFT', '10');
            $tpl->set('d', 'TEXT', '&nbsp;');
            $tpl->set('d', 'NUMBEROFARTICLES', '');
            $tpl->set('d', 'TOTAL', '');
            $tpl->set('d', 'STATUS', '');
            $tpl->set('d', 'ICON','');
            $tpl->set('d', 'BORDERCOLOR', $cfg["color"]["table_border"]);
            $tpl->set('d', 'INTHISLANGUAGE', '');
            $tpl->next();
            $currentRow++;
    	}

    	$padding_left 	= 10 + ( 15 * $db->f("level") );
        $text 			= $db->f(4);
        $idcat			= $db->f("idcat");

        $db2 = new DB_Contenido;
        //************** number of arts **************
        $sql = "SELECT COUNT(*) FROM ".$cfg["tab"]["cat_art"]." WHERE idcat='$idcat'";
        $db2->query($sql);
        $db2->next_record();

        $numberOfArticles = $db2->f(0);
		$sumNumberOfArticles += $numberOfArticles;
        $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat_archive"]." AS B WHERE A.idcatart=B.idcatart AND A.idcat='$idcat' AND B.idclient='$client' AND SUBSTRING(B.archived,1,4) = ".$year . " GROUP BY SUBSTRING(B.archived,1,4)";

        $db2->query($sql);
        $db2->next_record();

        $total = $db2->f(0);

        //************** hits of category in this language ***************
        $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat_archive"]." AS B WHERE A.idcatart=B.idcatart AND A.idcat='$idcat' AND B.idlang='$lang' AND B.idclient='$client' AND SUBSTRING(B.archived,1,4) = ".$year . " GROUP BY SUBSTRING(B.archived,1,4)";


        $db2->query($sql);
        $db2->next_record();

        $inThisLanguage = $db2->f(0);

        $icon = '<img src="'.$cfg['path']['images'].'folder.gif">';

        //************ art ********************************
        $sql = "SELECT * FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["art"]." AS B, ".$cfg["tab"]["art_lang"]." AS C WHERE A.idcat='$idcat' AND A.idart=B.idart AND B.idart=C.idart AND C.idlang='$lang' ORDER BY B.idart";
        $db2->query($sql);

        $numrows = $db2->num_rows();
        //$onclick = 'onClick="toggleRows('.$db->f("level").');"';
        $onclick = "";

        $online = $db->f("visible");
        if ($online == 1) {
            $offonline = '<img src="'.$cfg['path']['images'].'offline.gif" alt="Kategorie ist offline" title="Kategorie ist unsichtbar">';
        } else {
            $offonline = '<img src="'.$cfg['path']['images'].'online.gif" alt="Kategorie ist online" title="Kategorie ist sichtbar">';
        }
        $bgcolor = $cfg["color"]["table_dark"];
        $tpl->set('d', 'BGCOLOR', $bgcolor);
        $tpl->set('d', 'PADDING_LEFT', $padding_left);
        $tpl->set('d', 'TEXT', $text);
        $tpl->set('d', 'ONCLICK', $onclick);
        $tpl->set('d', 'ICON', $icon);
        $tpl->set('d', 'STATUS', $offonline);
        $tpl->set('d', 'NUMBEROFARTICLES', $numberOfArticles);
        $tpl->set('d', 'TOTAL', $total);
        $tpl->set('d', 'ROWNAME', "HIDE".$db->f("level"));
        $tpl->set('d', 'BORDERCOLOR', $cfg["color"]["table_border"]);
        $tpl->set('d', 'INTHISLANGUAGE', $inThisLanguage);
        $tpl->next();
        $currentRow++;

        $onclick = "";

        $text             = "";
        $numberOfArticles = "";
        $total            = "";
        $inThisLanguage   = "";

        while ($db2->next_record()) {
            $idart = $db2->f("idart");

            $text             = "";
            $numberOfArticles = "";
            $total            = "";
            $inThisLanguage   = "";

    	    $padding_left = 10 + ( 15 * ($db->f("level")+1) );

            $text = $db2->f("title");
            $online = $db2->f("online");

            //************** number of arts **************
          	$db3 = new DB_contenido;

           	//************** hits of art total **************
            $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat_archive"]." AS B WHERE A.idcatart=B.idcatart AND A.idcat='$idcat' AND A.idart='$idart' AND B.idclient='$client' AND SUBSTRING(B.archived,1,4) = ".$year . " GROUP BY SUBSTRING(B.archived,1,4)";
            
            $db3->query($sql);
            $db3->next_record();

            $total = $db3->f(0);

            //************** hits of art in this language ***************
            $sql = "SELECT visited FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat_archive"]." AS B WHERE A.idcatart=B.idcatart AND A.idcat='$idcat' AND A.idart='$idart' AND B.idlang='$lang' AND B.idclient='$client' AND SUBSTRING(B.archived,1,4) = ".$year . " GROUP BY SUBSTRING(B.archived,1,4)";
          	
            $db3->query($sql);
            $db3->next_record();

            $inThisLanguage = $db3->f(0);

            if ($online == 0) {
                $offonline = '<img src="'.$cfg['path']['images'].'offline.gif" alt="Artikel ist offline" title="Artikel ist offline">';
            } else {
                $offonline = '<img src="'.$cfg['path']['images'].'online.gif" alt="Artikel ist online" title="Artikel ist online">';
            }

            $icon = '<img src="'.$cfg['path']['images'].'article.gif">';
            $bgcolor = $cfg["color"]["table_light"];
            $tpl->set('d', 'BGCOLOR', $bgcolor);
            $tpl->set('d', 'PADDING_LEFT', $padding_left);
            $tpl->set('d', 'TEXT', $text);
            $tpl->set('d', 'ONCLICK', "");
            $tpl->set('d', 'ICON', $icon);
            $tpl->set('d', 'STATUS', $offonline);
            $tpl->set('d', 'ROWNAME', "HIDE".($db->f("level")+1));
            $tpl->set('d', 'NUMBEROFARTICLES', $numberOfArticles);
            $tpl->set('d', 'TOTAL', $total);
            $tpl->set('d', 'BORDERCOLOR', $cfg["color"]["table_border"]);
            $tpl->set('d', 'INTHISLANGUAGE', $inThisLanguage);
            $tpl->next();
            $currentRow++;
        }
    }

    //************** hits total**************
    $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat_archive"]." AS B WHERE A.idcatart=B.idcatart AND B.idclient='$client' AND SUBSTRING(B.archived,1,4) = ".$year . " GROUP BY SUBSTRING(B.archived,1,4)";

    //$sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["stat"]." WHERE idclient='$client'";
    $db->query($sql);
    $db->next_record();

    $total = $db->f(0);

    //************** hits total on this language ***************
    $sql = "SELECT SUM(visited) FROM ".$cfg["tab"]["cat_art"]." AS A, ".$cfg["tab"]["stat_archive"]." AS B WHERE A.idcatart=B.idcatart AND B.idlang='$lang' AND B.idclient='$client' AND SUBSTRING(B.archived,1,4) = ".$year . " GROUP BY SUBSTRING(B.archived,1,4)";

    $db->query($sql);
    $db->next_record();

    $inThisLanguage = $db->f(0);

    $bgcolor = '#FFFFFF';
    $tpl->set('d', 'BGCOLOR', $bgcolor);
    $tpl->set('d', 'BORDERCOLOR', $cfg["color"]["table_border"]);
    $tpl->set('d', 'TEXT', '&nbsp;');
    $tpl->set('d', 'ICON', '');
    $tpl->set('d', 'STATUS', '');
    $tpl->set('d', 'PADDING_LEFT', '10');
    $tpl->set('d', 'NUMBEROFARTICLES', '');
    $tpl->set('d', 'TOTAL', '');
    $tpl->set('d', 'INTHISLANGUAGE', '');

    $bgcolor = $cfg["color"]["table_dark"];
    $tpl->set('s', 'SUMBGCOLOR', $cfg["color"]["table_dark"]);
    $tpl->set('s', 'SUMTEXT', "Summe");
    $tpl->set('s', 'SUMNUMBEROFARTICLES', $sumNumberOfArticles);
    $tpl->set('s', 'SUMTOTAL', $total);
    $tpl->set('s', 'SUMINTHISLANGUAGE', $inThisLanguage);
    $tpl->next();
}

/**
 * Generates a top<n> statistics page
 *
 * @param $yearmonth  Specifies the year and month from which to retrieve the
 *                    statistics, specify "current" to retrieve the current
 *                    entries
 * @param $top        Specifies the amount of pages to display
 *
 * @author Timo A. Hummel <Timo.Hummel@4fb.de>
 * @copyright four for business AG <http://www.4fb.de>
 *
 * @return none
 *
 */
function statsOverviewTop($yearmonth, $top)
{
    global $cfg, $db, $tpl, $client, $lang;

    if (strcmp($yearmonth,"current") == 0)
    {
    $sql = "SELECT
                C.title, A.visited
            FROM ".$cfg["tab"]["stat"]." AS A,
                 ".$cfg["tab"]["cat_art"]." AS B,
                 ".$cfg["tab"]["art_lang"]." AS C
            WHERE
                C.idart = B.idart
            AND
                C.idlang = A.idlang
            AND
                B.idcatart = A.idcatart
            AND
                A.idclient = '".$client."'
            AND
                A.idlang = ".$lang."
            ORDER BY
                A.visited DESC

            LIMIT
                ".$top;
    } else {
    $sql = "SELECT
                C.title, A.visited, B.idcat
            FROM ".$cfg["tab"]["stat_archive"]." AS A,
                 ".$cfg["tab"]["cat_art"]." AS B,
                 ".$cfg["tab"]["art_lang"]." AS C
            WHERE
                C.idart = B.idart
            AND
                C.idlang = A.idlang
            AND
                B.idcatart = A.idcatart
            AND
                A.idclient = '".$client."'
            AND
                A.archived = ".$yearmonth."
            AND
                A.idlang = ".$lang."
            ORDER BY
                A.visited DESC
            LIMIT
                ".$top;
    }

    $db->query($sql);

    while ($db->next_record()) {
        $cat_name = "";
        statCreateLocationString($db->f(2),"&nbsp;/&nbsp;", $cat_name);
        $bgcolor = $cfg["color"]["table_light"];
        $tpl->set('d', 'BGCOLOR', $bgcolor);
        $tpl->set('d', 'PADDING_LEFT', '0');
        $tpl->set('d', 'PATH', "Pfad:&nbsp;/&nbsp;".$cat_name);
        $tpl->set('d', 'BORDERCOLOR', $cfg["color"]["table_border"]);
        $tpl->set('d', 'TEXT',  $db->f(0));
        $tpl->set('d', 'TOTAL', $db->f(1));
        $tpl->next();
    }
}

function statReturnCanonicalMonth($month)
{
	return getCanonicalMonth($month);
}

function statCreateLocationString($idcat, $seperator, &$cat_str) {

    global $cfg, $db, $client, $lang;

    $sql = "SELECT
                a.name AS name,
                a.idcat AS idcat,
                b.parentid AS parentid
            FROM
                ".$cfg["tab"]["cat_lang"]." AS a,
                ".$cfg["tab"]["cat"]." AS b
            WHERE
                a.idlang    = '".$lang."' AND
                b.idclient  = '".$client."' AND
                b.idcat     = '".$idcat."' AND
                a.idcat     = b.idcat";

    $db4 = new DB_Contenido;
    $db4->query($sql);
    $db4->next_record();

    $name       = $db4->f("name");
    $parentid   = $db4->f("parentid");

    $tmp_cat_str = $name . $seperator . $cat_str;
    $cat_str = $tmp_cat_str;

    if ( $parentid != 0 ) {
        statCreateLocationString($parentid, $seperator, $cat_str);

    } else {
        $sep_length = strlen($seperator);
        $str_length = strlen($cat_str);
        $tmp_length = $str_length - $sep_length;
        $cat_str = substr($cat_str, 0, $tmp_length);
    }
}

/**
 * Generates a top<n> statistics page
 *
 * @param $year       Specifies the year from which to retrieve the
 *                    statistics
 * @param $top        Specifies the amount of pages to display
 *
 * @author Timo A. Hummel <Timo.Hummel@4fb.de>
 * @copyright four for business AG <http://www.4fb.de>
 *
 * @return none
 *
 */
function statsOverviewTopYear($year, $top)
{
    global $cfg, $db, $tpl, $client, $lang;

    $sql = "SELECT
                C.title, SUM(A.visited) as visited
            FROM ".$cfg["tab"]["stat_archive"]." AS A,
                 ".$cfg["tab"]["cat_art"]." AS B,
                 ".$cfg["tab"]["art_lang"]." AS C
            WHERE
                C.idart = B.idart
            AND
                C.idlang = A.idlang
            AND
                B.idcatart = A.idcatart
            AND
                A.idclient = \"".$client."\"
            AND
                A.archived LIKE \"".$year."%\"
            AND
                A.idlang = ".$lang."
            GROUP BY A.idcatart
            ORDER BY
                visited DESC

            LIMIT
                ".$top;

    $db->query($sql);

    while ($db->next_record()) {
        $bgcolor = $cfg["color"]["table_light"];
        $tpl->set('d', 'BGCOLOR', $bgcolor);
        $tpl->set('d', 'PADDING_LEFT', '0');
        $tpl->set('d', 'BORDERCOLOR', $cfg["color"]["table_border"]);
        $tpl->set('d', 'TEXT', $db->f(0));
        $tpl->set('d', 'TOTAL', $db->f(1));
        $tpl->next();
    }
}
/**
 * Returns a drop down to choose the stats to display
 *
 * @param none
 * @author Timo A. Hummel <Timo.Hummel@4fb.de>
 * @copyright four for business AG <http://www.4fb.de>
 *
 * @return string Returns a drop down string
 *
 */
function statDisplayTopChooser($default)
{

     if ($default == "top10") { $defaultTop10 = "selected";}
     if ($default == "top20") { $defaultTop20 = "selected";}
     if ($default == "top30") { $defaultTop30 = "selected";}
     if ($default == "all")   { $defaultAll = "selected";}

     return ("<form name=\"name\">" .
             "  <select class=\"text_medium\" onchange=\"top10Action(this)\">".
             "    <option value=\"top10\" $defaultTop10>".i18n("Top 10")."</option>".
             "    <option value=\"top20\" $defaultTop20>".i18n("Top 20")."</option>".
             "    <option value=\"top30\" $defaultTop30>".i18n("Top 30")."</option>".
             "    <option value=\"all\" $defaultAll>".i18n("All")."</option>".
             "  </select>".
             "</form>");

}

/**
 * Returns a drop down to choose the stats to display for yearly summary pages
 *
 * @param none
 * @author Timo A. Hummel <Timo.Hummel@4fb.de>
 * @copyright four for business AG <http://www.4fb.de>
 *
 * @return string Returns a drop down string
 *
 */
function statDisplayYearlyTopChooser($default)
{

     if ($default == "top10") { $defaultTop10 = "selected";}
     if ($default == "top20") { $defaultTop20 = "selected";}
     if ($default == "top30") { $defaultTop30 = "selected";}
     if ($default == "all")   { $defaultAll = "selected";}

     return ("<form name=\"name\">" .
             "  <select class=\"text_medium\" onchange=\"top10ActionYearly(this)\">".
             "    <option value=\"top10\" $defaultTop10>".i18n("Top 10")."</option>".
             "    <option value=\"top20\" $defaultTop20>".i18n("Top 20")."</option>".
             "    <option value=\"top30\" $defaultTop30>".i18n("Top 30")."</option>".
             "    <option value=\"all\" $defaultAll>".i18n("All")."</option>".
             "  </select>".
             "</form>");

}

/**
 * Return an array with all years which are available as stat files
 *
 * @param mixed many
 * @author Timo A. Hummel <Timo.Hummel@4fb.de>
 * @copyright four for business AG <http://www.4fb.de>
 *
 * @return array  Array of strings with years.
 */
function statGetAvailableYears ($client, $lang)
{
         global $cfg, $db;
         
         $availableYears = array();
         
         $sql =    "SELECT SUBSTRING(`archived`,1,4)
                    FROM
                        ".$cfg["tab"]["stat_archive"]."
                    WHERE
                        idlang = '".$lang."' AND
                        idclient = '".$client."'
                    GROUP BY
                        SUBSTRING(`archived`,1,4)
                    ORDER BY
                        SUBSTRING(`archived`,1,4) DESC";
                        
        $db->Query($sql);
         while ($db->next_record())
         {
           array_push($availableYears, $db->f(0));
         }
         
         return($availableYears);
}

/**
 * Return an array with all months for a specific year which are available
 * as stat files
 *
 * @param mixed many
 * @author Timo A. Hummel <Timo.Hummel@4fb.de>
 * @copyright four for business AG <http://www.4fb.de>
 *
 * @return array  Array of strings with months.
 */
function statGetAvailableMonths ($year, $client, $lang)
{
         global $cfg, $db;

         $availableYears = array();

         $sql =    "SELECT SUBSTRING(`archived`,5,2)
                    FROM
                        ".$cfg["tab"]["stat_archive"]."
                    WHERE
                        idlang = '".$lang."' AND
                        idclient = '".$client."' AND
                        SUBSTRING(`archived`,1,4) = '".$year."'
                    GROUP BY
                        SUBSTRING(`archived`,5,2)
                    ORDER BY SUBSTRING(`archived`,5,2) DESC";

        $db->Query($sql);
         while ($db->next_record())
         {
           array_push($availableYears, $db->f(0));
         }

         return($availableYears);
}

function statResetStatistic ($client) {
        global $db;
        global $cfg;

        $sql = "UPDATE ".$cfg["tab"]["stat"]." SET visited=0 WHERE idclient='$client'";
         $db->query($sql);
}








?>
