<?php
/*****************************************
* File      :   $RCSfile: include.newsletter_menu.php,v $
* Project   :   Contenido
* Descr     :   Frontend user list
* Modified  :   $Date: 2007/08/02 23:15:00 $
*
*  four for business AG, www.4fb.de, updated by HerrB
*
* $Id: include.newsletter_menu.php,v 1.20 2007/08/02 23:15:00 bjoern.behrens Exp $
******************************************/
cInclude("classes", "widgets/class.widgets.page.php");
cInclude("classes", "widgets/class.widgets.foldingrow.php");
cInclude("classes", "widgets/class.widgets.pager.php");
cInclude("classes", "class.newsletter.php");
cInclude("classes", "class.newsletter.groups.php");
cInclude("classes", "contenido/class.user.php");
cInclude("classes", "contenido/class.clientslang.php");
cInclude("classes", "class.ui.php");

$oPage			= new cPage;
$oMenu			= new UI_Menu;

$oClientLang 	= new cApiClientLanguage(false, $client, $lang);
$lIDCatArt		= (int)$oClientLang->getProperty("newsletter", "idcatart"); // Get idCatArt to check, if we may send a test newsletter

if (!is_object($oDB)) {
	$oDB = new DB_Contenido; // We have really to send a special SQL statement - we need a DB object
}

// Check, set and save values
// Items per page (value stored per area in user property)
$oUser = new cApiUser($auth->auth["uid"]);
if (!isset($_REQUEST["elemperpage"]) || !is_numeric($_REQUEST["elemperpage"]) || $_REQUEST["elemperpage"] < 0) {
	$_REQUEST["elemperpage"] = $oUser->getProperty("itemsperpage", $area);
}
if (!is_numeric($_REQUEST["elemperpage"])) {
	$_REQUEST["elemperpage"] = 25;
}
if ($_REQUEST["elemperpage"] > 0) { 
	// -- All -- will not be stored, as it may be impossible to change this back to something more useful
	$oUser->setProperty("itemsperpage", $area, $_REQUEST["elemperpage"]);
}

// Current page
if (!isset($_REQUEST["page"]) || !is_numeric($_REQUEST["page"]) || $_REQUEST["page"] <= 0 || $_REQUEST["elemperpage"] == 0) {
	$_REQUEST["page"] = 1;
}

// Sort order
if ($_REQUEST["sortorder"] != "DESC") {
	$_REQUEST["sortorder"]  = "ASC";
}

// HTML Newsletter: idcat containing HTML newsletter template articles (stored per client/lang property)
if ($_REQUEST["selHTMLTemplateCat"] == "" || !$perm->have_perm_area_action($area, "news_html_settings")) {
	$_REQUEST["selHTMLTemplateCat"] = $oClientLang->getProperty("newsletter", "html_template_idcat");
}
if (!is_numeric($_REQUEST["selHTMLTemplateCat"]) || $_REQUEST["selHTMLTemplateCat"] < 0) {
	$_REQUEST["selHTMLTemplateCat"] = 0;
}

// HTML Newsletter: idcat containing HTML newsletter articles (stored per client/lang property)
if ($_REQUEST["selHTMLNewsletterCat"] == "" || !$perm->have_perm_area_action($area, "news_html_settings")) {
	$_REQUEST["selHTMLNewsletterCat"] = $oClientLang->getProperty("newsletter", "html_newsletter_idcat");
}
if (!is_numeric($_REQUEST["selHTMLNewsletterCat"]) || $_REQUEST["selHTMLNewsletterCat"] < 0) {
	$_REQUEST["selHTMLNewsletterCat"] = 0;
}

// HTML Newsletter: Store settings
if ($perm->have_perm_area_action($area, "news_html_settings"))
{
	$oClientLang->setProperty("newsletter", "html_template_idcat",   $_REQUEST["selHTMLTemplateCat"]);
	$oClientLang->setProperty("newsletter", "html_newsletter_idcat", $_REQUEST["selHTMLNewsletterCat"]);
}

// HTML Newsletter: Deactivate HTML newsletters, if necessary idcats have not been specified
if ($_REQUEST["selHTMLTemplateCat"] == 0 || $_REQUEST["selHTMLNewsletterCat"] == 0) {
	unset ($_REQUEST["ckbHTMLNewsletter"]);
}

// Send test destination
if (!isset($_REQUEST["selTestDestination"]) || !is_numeric($_REQUEST["selTestDestination"]) || $_REQUEST["selTestDestination"] < 0) {
	$_REQUEST["selTestDestination"] = $oUser->getProperty("newsletter", "test_idnewsgrp");
}
if (!is_numeric($_REQUEST["selTestDestination"]) || !$perm->have_perm_area_action($area, "news_send_test")) {
	$_REQUEST["selTestDestination"] = 0; // E-Mail address of current user
} 
$oUser->setProperty("newsletter", "test_idnewsgrp", $_REQUEST["selTestDestination"]);

// Initialization
$aFields = array();
$aFields["name"] = array("field" => "name", "caption" => i18n("Name"), "type" => "base,sort,search");

$sSendTestTitle		= i18n("Send test newsletter");
$sSendTestTitleOff	= i18n("Send test newsletter (disabled, check newsletter sender e-mail address and handler article selection)");
# $sSendTestDescr will be specified below, after destination select box preparation
$sCurrentUser		= $oUser->get("realname"). " (" . $oUser->get("email") . ")";
$sAddJobTitle		= i18n("Add newsletter dispatch job");
$sAddJobTitleOff	= i18n("Add newsletter dispatch job (disabled, check newsletter sender e-mail address and handler article selection)");
$sCopyTitle			= i18n("Duplicate newsletter");
$sDelTitle			= i18n("Delete newsletter");
$sDelDescr 			= i18n("Do you really want to delete the following newsletter:<br>");

unset ($oUser); // Object not needed anymore

// Actions folding row
$oActionRow = new cFoldingRow("28cf9b31-e6d7-4657-a9a7-db31478e7a5c",i18n("Actions"));

// Create the link to add a newsletter
$sContent  = '<div style="padding: 4px; padding-left: 12px; border-bottom: 1px solid black; background: '.$cfg['color']['table_dark'].';">'.chr(10);

if ($perm->have_perm_area_action($area, "news_create"))
{
	$oLink = new cHTMLLink;
	$oLink->setMultiLink("news","","news","news_create");
	$oLink->setContent('<img style="margin-right: 4px;" src="'.$cfg["path"]["images"] . 'newsletter.gif" align="middle">'.i18n("Create newsletter"));
	
	$sContent .= $oLink->render();
}
$sContent .= '</div>'.chr(10);

$oActionRow->setContentData($sContent);

// Settings folding row
$oSettingsRow = new cFoldingRow("d64baf0a-aea9-47b3-8490-54a00fce02b5",i18n("Settings"));

// HTML Newsletter: Enabled option
$bHTMLNewsletter = false;
if (isset($_REQUEST["ckbHTMLNewsletter"]) && $perm->have_perm_area_action($area, "news_html_settings"))
{
	$bHTMLNewsletter = true;
	$oClientLang->setProperty("newsletter", "html_newsletter", "true");
} else if ($_REQUEST["action_html"] == "save" && $perm->have_perm_area_action($area, "news_html_settings")) {
	$oClientLang->setProperty("newsletter", "html_newsletter", "false");
} else if ($oClientLang->getProperty("newsletter", "html_newsletter") == "true") {
	$bHTMLNewsletter = true;
}
$oCkbHTMLNewsletter 		= new cHTMLCheckbox("ckbHTMLNewsletter", "enabled", "", $bHTMLNewsletter);

// HTML Newsletter: Template and newsletter category
// Note, that in PHP 5 it is not possible to have a truely working copy of an object
// so, we are filling two almost identical objects with the same data ("clone" may work, but is not available in PHP4 ...)
$oSelHTMLTemplateIDCat		= new cHTMLSelectElement("selHTMLTemplateCat");
$oSelHTMLNewsletterIDCat	= new cHTMLSelectElement("selHTMLNewsletterCat");

$oOptionTemplate			= new cHTMLOptionElement("--".i18n("Please select")."--", 0);
$oSelHTMLTemplateIDCat->addOptionElement(0, $oOptionTemplate);
$oOptionNewsletter			= new cHTMLOptionElement("--".i18n("Please select")."--", 0);
$oSelHTMLNewsletterIDCat->addOptionElement(0, $oOptionNewsletter);

$sSQL  = "SELECT tblCat.idcat AS idcat, tblCatLang.name AS name, tblCatTree.level AS level, ";
$sSQL .= "tblCatLang.visible AS visible, tblCatLang.public AS public FROM ";
$sSQL .= $cfg["tab"]["cat"]." AS tblCat, ".$cfg["tab"]["cat_lang"]." AS tblCatLang, ";
$sSQL .= $cfg["tab"]["cat_tree"]." AS tblCatTree ";
$sSQL .= "WHERE tblCat.idclient = '".$client."' AND tblCatLang.idlang = '".$lang."' AND ";
$sSQL .= "tblCatLang.idcat = tblCat.idcat AND tblCatTree.idcat = tblCat.idcat ";
$sSQL .= "ORDER BY tblCatTree.idtree";

$oDB->query($sSQL);

while ($oDB->next_record()) {
	$sSpaces = "&nbsp;&nbsp;";

	for ($i = 0; $i < $oDB->f("level"); $i ++) {
		$sSpaces .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
	}

	$oOptionTemplate	= new cHTMLOptionElement($sSpaces.$oDB->f("name"), $oDB->f("idcat"));
	$oOptionNewsletter	= new cHTMLOptionElement($sSpaces.$oDB->f("name"), $oDB->f("idcat"));
	if ($oDB->f("visible") == 0 || $oDB->f("public") == 0) {
		$oOptionTemplate->setStyle("color: #666666;");
		$oOptionNewsletter->setStyle("color: #666666;");
	}
	$oSelHTMLTemplateIDCat->addOptionElement($oDB->f("idcat"), $oOptionTemplate);
	$oSelHTMLNewsletterIDCat->addOptionElement($oDB->f("idcat"), $oOptionNewsletter);
}
$oSelHTMLTemplateIDCat->setStyle("width: 220px;");
$oSelHTMLTemplateIDCat->setDefault($_REQUEST["selHTMLTemplateCat"]);

$oSelHTMLNewsletterIDCat->setStyle("width: 220px;");
$oSelHTMLNewsletterIDCat->setDefault($_REQUEST["selHTMLNewsletterCat"]);

# Disable HTML options, if user has no rights
if (!$perm->have_perm_area_action($area, "news_html_settings"))
{
	$oSelHTMLTemplateIDCat->setDisabled("disabled");
	$oSelHTMLNewsletterIDCat->setDisabled("disabled");
	$oCkbHTMLNewsletter->setDisabled("disabled");
}

// Destination for sending test newsletter
$oSelTestDestination	= new cHTMLSelectElement("selTestDestination");

$oOption = new cHTMLOptionElement(i18n("My mail address"), 0);
$oSelTestDestination->addOptionElement(0, $oOption);

$oRcpGroups = new RecipientGroupCollection;
$oRcpGroups->setWhere("idclient", $client);
$oRcpGroups->setWhere("idlang", $lang);
$oRcpGroups->setOrder("groupname");
$oRcpGroups->query();

$sSendTestTarget = "";
while ($oRcpGroup = $oRcpGroups->next())
{
	$iID = $oRcpGroup->get($oRcpGroup->primaryKey);
	
	if ($_REQUEST["selTestDestination"] == $iID) {
		$sSendTestTarget = sprintf(i18n("Recipient group: %s"), $oRcpGroup->get("groupname"));
	}
	
	$oOption = new cHTMLOptionElement($oRcpGroup->get("groupname"), $iID);
	$oSelTestDestination->addOptionElement($iID, $oOption);
}

if ($sSendTestTarget == "")
{
	$_REQUEST["selTestDestination"] = 0;
	$sSendTestTarget = $sCurrentUser;
} 

$oSelTestDestination->setStyle("width: 220px;");
$oSelTestDestination->setDefault($_REQUEST["selTestDestination"]);
if (!$perm->have_perm_area_action($area, "news_send_test"))
{
	$oSelTestDestination->setDisabled("disabled"); // No right to send somewhere else than to yourself
}
$sSendTestDescr = sprintf(i18n("Do you really want to send the newsletter to:<br><strong>%s</strong>"), $sSendTestTarget);

$oBtnSubmitSettings = new cHTMLButton("submit", i18n("Save"));

$sContent  = '<div style="border-bottom: 1px solid black; background: '.$cfg['color']['table_dark'].';">'.chr(10);
$sContent .= '  <form onsubmit="append_registered_parameters(this);" id="htmlnewsletter" name="htmlnewsletter" method="get" action="main.php?1">'.chr(10);
$sContent .= '   <input type="hidden" name="area" value="'.$area.'">'.chr(10);
$sContent .= '   <input type="hidden" name="frame" value="'.$frame.'">'.chr(10);
$sContent .= '   <input type="hidden" name="contenido" value="'.$sess->id.'">'.chr(10);
$sContent .= '   <input type="hidden" name="elemperpage" value="'.$_REQUEST["elemperpage"].'">'.chr(10);
$sContent .= '   <input type="hidden" name="sortby" value="'.$_REQUEST["sortby"].'">'.chr(10);
$sContent .= '   <input type="hidden" name="sortorder" value="'.$_REQUEST["sortorder"].'">'.chr(10);
$sContent .= '   <input type="hidden" name="restrictgroup" value="'.$_REQUEST["restrictgroup"].'">'.chr(10);
$sContent .= '   <input type="hidden" name="filter" value="'.$_REQUEST["filter"].'">'.chr(10);
$sContent .= '   <input type="hidden" name="searchin" value="'.$_REQUEST["searchin"].'">'.chr(10);
$sContent .= '   <input type="hidden" name="action_html" value="save">'.chr(10);
$sContent .= '   <table>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'.$oCkbHTMLNewsletter->toHTML(false).' '.i18n("Enable HTML Newsletter").'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'.i18n("HTML Template Category:").'<br />'.$oSelHTMLTemplateIDCat->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'.i18n("HTML Newsletter Category:").'<br />'.$oSelHTMLNewsletterIDCat->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'.i18n("Send test destination:").'<br />'.$oSelTestDestination->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td style="text-align: right;">'.$oBtnSubmitSettings->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '    </table>'.chr(10);
$sContent .= '  </form>'.chr(10);
$sContent .= '</div>'.chr(10);
$oSettingsRow->setContentData($sContent);

// List options folding row
$oListOptionRow = new cFoldingRow("9d0968be-601d-44f8-a666-99d51c9c777d",i18n("List options"));

$oSelectItemsPerPage = new cHTMLSelectElement("elemperpage");
$oSelectItemsPerPage->autoFill(array(0 => i18n("-- All --"), 25 => 25, 50 => 50, 75 => 75, 100 => 100));
$oSelectItemsPerPage->setDefault($_REQUEST["elemperpage"]);

$oSelectSortBy = new cHTMLSelectElement("sortby");
foreach ($aFields as $sKey => $aData) {
	if (strpos($aData["type"], "sort") !== false) {
		if ($_REQUEST["sortby"] == "") {
			$_REQUEST["sortby"] = $sKey;
		}
		$oOption = new cHTMLOptionElement($aData["caption"], $sKey);
		$oSelectSortBy->addOptionElement($sKey, $oOption);
	}
}	
$oSelectSortBy->setDefault($_REQUEST["sortby"]);

$oSelectSortOrder = new cHTMLSelectElement("sortorder");
$oSelectSortOrder->autoFill(array("ASC" => i18n("Ascending"), "DESC" => i18n("Descending")));
$oSelectSortOrder->setDefault($_REQUEST["sortorder"]);

$oTextboxFilter = new cHTMLTextbox("filter", $_REQUEST["filter"], 16);

$oSelectSearchIn = new cHTMLSelectElement("searchin");
$oOption = new cHTMLOptionElement(i18n("-- All fields --"), "--all--");
$oSelectSearchIn->addOptionElement("all", $oOption);

foreach ($aFields as $sKey => $aData) {
	if (strpos($aData["type"], "search") !== false) {
		$oOption = new cHTMLOptionElement($aData["caption"], $sKey);
		$oSelectSearchIn->addOptionElement($sKey, $oOption);
	}
}
$oSelectSearchIn->setDefault($_REQUEST["searchin"]);

$oSubmit = new cHTMLButton("submit", i18n("Apply"));

$sContent  = '<div style="border-bottom: 1px solid black; background: '.$cfg['color']['table_dark'].';">'.chr(10);
$sContent .= '<form onsubmit="append_registered_parameters(this);" id="filterform" name="filterform" method="get" action="main.php?1">'.chr(10);
$sContent .= '   <input type="hidden" name="area" value="'.$area.'">'.chr(10);
$sContent .= '   <input type="hidden" name="frame" value="'.$frame.'">'.chr(10);
$sContent .= '   <input type="hidden" name="contenido" value="'.$sess->id.'">'.chr(10);
$sContent .= '   <table>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'. i18n("Items / page").'</td>'.chr(10);
$sContent .= '         <td>'.$oSelectItemsPerPage->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'. i18n("Sort by").'</td>'.chr(10);
$sContent .= '         <td>'.$oSelectSortBy->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'. i18n("Sort order").'</td>'.chr(10);
$sContent .= '         <td>'.$oSelectSortOrder->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'. i18n("Search for").'</td>'.chr(10);
$sContent .= '         <td>'.$oTextboxFilter->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>'. i18n("Search in").'</td>'.chr(10);
$sContent .= '         <td>'.$oSelectSearchIn->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '      <tr>'.chr(10);
$sContent .= '         <td>&nbsp;</td>'.chr(10);
$sContent .= '         <td>'.$oSubmit->render().'</td>'.chr(10);
$sContent .= '      </tr>'.chr(10);
$sContent .= '    </table>'.chr(10);
$sContent .= '</form>'.chr(10);
$sContent .= '</div>'.chr(10);
$oListOptionRow->setContentData($sContent);

// Request data
$oNewsletters = new NewsletterCollection;
$oNewsletters->setWhere("idclient", $client);
$oNewsletters->setWhere("idlang", $lang);

if ($_REQUEST["filter"] != "") {
	if ($_REQUEST["searchin"] == "--all--" || $_REQUEST["searchin"] == "") {
		foreach ($aFields as $sKey => $aData) {
			if (strpos($aData["type"], "search") !== false) {
				$oNewsletters->setWhereGroup("filter", $aData["field"], $_REQUEST["filter"], "LIKE");
			}
		}
		$oNewsletters->setInnerGroupCondition("filter", "OR");
	} else {
		$oNewsletters->setWhere($_REQUEST["searchin"], $_REQUEST["filter"], "LIKE");
	}
}

if ($_REQUEST["elemperpage"] > 0) {
	$oNewsletters->query();
	$iItemCount = $oNewsletters->count(); // Getting item count without limit (for page function) - better idea anyone (performance)?
	
	$oNewsletters->setLimit($_REQUEST["elemperpage"] * ($_REQUEST["page"] - 1), $_REQUEST["elemperpage"]);
} else {
	$iItemCount = 0;
}

$oNewsletters->setOrder("welcome DESC, " . $_REQUEST["sortby"]." ".$_REQUEST["sortorder"]);
$oNewsletters->query();

// Output data
$oMenu	= new UI_Menu;
$iMenu	= 0;
while ($oNewsletter = $oNewsletters->next()) {
	$idnewsletter = $oNewsletter->get("idnews");
	$iMenu++;
	
	$sName = $oNewsletter->get("name");
	if ($oNewsletter->get("welcome")) {
		$sName = $sName . "*";
	}

	// Create the link to show/edit the newsletter
	$oLnk = new cHTMLLink;
	$oLnk->setMultiLink($area, "", $area, "");
	$oLnk->setCustom("idnewsletter", $idnewsletter);
	
	$oMenu->setTitle($iMenu, $sName);
	$oMenu->setLink($iMenu, $oLnk);
	
	if ($perm->have_perm_area_action($area, "news_add_job") ||
	    $perm->have_perm_area_action($area, "news_create") ||
	    $perm->have_perm_area_action($area, "news_save"))
	{
		// Rights: If you are able to add a job, you should be able to test it
		//         If you are able to add or change a newsletter, you should be able to test it
		// Usability: If no e-mail has been specified, you can't send a test newsletter
		if (isValidMail($oNewsletter->get("newsfrom")) && $lIDCatArt > 0)
		{
			$sLnkSendTest = '<a title="'.$sSendTestTitle.'" href="javascript://" onclick="showSendTestMsg('.$idnewsletter.')"><img src="'.$cfg['path']['images'].'newsletter_sendtest_16.gif" border="0" title="'.$sSendTestTitle.'" alt="'.$sSendTestTitle.'" /></a>';
		} else {
			$sLnkSendTest = '<img src="'.$cfg['path']['images'].'newsletter_sendtest_16_off.gif" border="0" title="'.$sSendTestTitleOff.'" alt="'.$sSendTestTitleOff.'" />';
		}
		$oMenu->setActions($iMenu, 'test', $sLnkSendTest);
	}
	
	if ($perm->have_perm_area_action($area, "news_add_job"))
	{
		if (isValidMail($oNewsletter->get("newsfrom")) && $lIDCatArt > 0)
		{
			$oLnkAddJob = new Link;
			$oLnkAddJob->setMultiLink("news","","news","news_add_job");
			$oLnkAddJob->setCustom("idnewsletter", $idnewsletter);
			$oLnkAddJob->setAlt($sAddJobTitle);
			$oLnkAddJob->setContent('<img src="'.$cfg['path']['images'].'newsletter_dispatch_16.gif" border="0" title="'.$sAddJobTitle.'" alt="'.$sAddJobTitle.'">');
			
			$sLnkAddJob = $oLnkAddJob->render();
		} else {
			$sLnkAddJob = '<img src="'.$cfg['path']['images'].'newsletter_dispatch_16_off.gif" border="0" title="'.$sAddJobTitleOff.'" alt="'.$sAddJobTitleOff.'" />';
		}
		
		$oMenu->setActions($iMenu, 'dispatch', $sLnkAddJob);
	}
	
	if ($perm->have_perm_area_action($area, "news_create"))
	{
		$oLnkCopy = new Link;
		$oLnkCopy->setMultiLink("news", "", "news", "news_duplicate");
		$oLnkCopy->setCustom("idnewsletter", $idnewsletter);
		$oLnkCopy->setAlt($sCopyTitle);
		$oLnkCopy->setContent('<img src="'.$cfg['path']['images'].'but_copy.gif" border="0" title="'.$sCopyTitle.'" alt="'.$sCopyTitle.'">');
	
		$oMenu->setActions($iMenu, 'copy', $oLnkCopy->render());
	}
	
	if ($perm->have_perm_area_action($area, "news_delete"))
	{ 
		$sDelete = '<a title="'.$sDelTitle.'" href="javascript://" onclick="showDelMsg('.$idnewsletter.',\''.addslashes($sName).'\')"><img src="'.$cfg['path']['images'].'delete.gif" border="0" title="'.$sDelTitle.'" alt="'.$sDelTitle.'"></a>';
			
		$oMenu->setActions($iMenu, 'delete', $sDelete);
	}
	$oMenu->setImage($iMenu, "images/newsletter.gif");	
}

$oPagerLink = new cHTMLLink;
$oPagerLink->setLink("main.php");
$oPagerLink->setCustom("elemperpage", $_REQUEST["elemperpage"]);
$oPagerLink->setCustom("filter", $_REQUEST["filter"]);
$oPagerLink->setCustom("restrictgroup", $_REQUEST["restrictgroup"]);
$oPagerLink->setCustom("sortby", $_REQUEST["sortby"]);
$oPagerLink->setCustom("sortorder", $_REQUEST["sortorder"]);
$oPagerLink->setCustom("searchin", $_REQUEST["searchin"]);
$oPagerLink->setCustom("restrictgroup", $_REQUEST["restrictgroup"]);
$oPagerLink->setCustom("frame", $frame);
$oPagerLink->setCustom("area", $area);
$oPagerLink->enableAutomaticParameterAppend();
$oPagerLink->setCustom("contenido", $sess->id);

$oPager     = new cObjectPager("0ed6d632-6adf-4f09-a0c6-1e38ab60e301", $iItemCount, $_REQUEST["elemperpage"], $_REQUEST["page"], $oPagerLink, "page");

$execScript = '
    <script type="text/javascript">
        /* Session-ID */
        var sid = "'.$sess->id.'";

        /* Create messageBox instance */
        box = new messageBox("", "", "", 0, 0);

        function showSendTestMsg(lngId) {
            box.confirm("'.$sSendTestTitle.'", "'.$sSendTestDescr.'", "sendTestNewsletter(\'" + lngId + "\')");
        }

        function showDelMsg(lngId, strElement) {
            box.confirm("'.$sDelTitle.'", "'.$sDelDescr.'<b>" + strElement + "</b>", "deleteNewsletter(\'" + lngId + "\')");
        }

		/* Enabled/Disable group box */
        function checkSelection(strValue)
        {
            if (strValue == "selection") {
                document.getElementById("groupselect").disabled = false;
            } else {
                document.getElementById("groupselect").disabled = true;
            }
        }

        /* Function for sending test newsletter */
        function sendTestNewsletter(idnewsletter)
        {
            oForm = document.getElementById("filterform");

            url  = "main.php?area=news";
            url += "&action=news_send_test";
            url += "&frame=4";
            url += "&idnewsletter=" + idnewsletter;
            url += "&contenido=" + sid;
            url += get_registered_parameters();
            url += "&sortby=" + oForm.sortby.value;
            url += "&sortorder=" + oForm.sortorder.value;
            url += "&filter=" + oForm.filter.value;
            url += "&elemperpage=" + oForm.elemperpage.value;

            parent.parent.right.right_bottom.location.href = url;
        }

        /* Function for deleting newsletters */
        function deleteNewsletter(idnewsletter)
        {
            oForm = document.getElementById("filterform");

            url  = "main.php?area=news";
            url += "&action=news_delete";
            url += "&frame=4";
            url += "&idnewsletter=" + idnewsletter;
            url += "&contenido=" + sid;
            url += get_registered_parameters();
            url += "&sortby=" + oForm.sortby.value;
            url += "&sortorder=" + oForm.sortorder.value;
            url += "&filter=" + oForm.filter.value;
            url += "&elemperpage=" + oForm.elemperpage.value;

            parent.parent.right.right_bottom.location.href = url;
        }
		</script>';

$oPage->setMargin(0);
$oPage->addScript('messagebox', '<script type="text/javascript" src="scripts/messageBox.js.php?contenido='.$sess->id.'"></script>');
$oPage->addScript('exec', $execScript);
$oPage->addScript('cfoldingrow.js', '<script language="JavaScript" src="scripts/cfoldingrow.js"></script>');
$oPage->addScript('parameterCollector.js', '<script language="JavaScript" src="scripts/parameterCollector.js"></script>');

$oPage->setContent(array('<table border="0" cellspacing="0" cellpadding="0" width="100%">', $oActionRow, $oSettingsRow, $oListOptionRow, $oPager, '</table>', $oMenu->render(false)));
$oPage->render();

?>