<?php
/******************************************
* File      :   include.rights_menu.php
* Project   :   Contenido
* Descr     :   Displays languages
*
* Author    :   Olaf Niemann
* Created   :   23.04.2003
* Modified  :   23.04.2003
*
*  four for business AG
*****************************************/
cInclude("classes", "widgets/class.widgets.page.php");
cInclude("classes", "widgets/class.widgets.foldingrow.php");
cInclude("classes", "widgets/class.widgets.pager.php");
cInclude("classes", "class.ui.php");

$users = new Users;


$oPage = new cPage;

$aSortByOptions = array(	"username" => i18n("User name"),
							"realname" => i18n("Name"));
						
$aSortOrderOptions = array(	"asc" => i18n("Ascending"),
							"desc" => i18n("Descending"));
							
$oListOptionRow = new cFoldingRow(	"5498dbba-ed4a-4618-8e49-3a3635396e22",
									i18n("List options"));

$oSelectItemsPerPage = new cHTMLSelectElement("elemperpage");
$oSelectItemsPerPage->autoFill(array(25 => 25, 50 => 50, 75 => 75, 100 => 100));
$oSelectItemsPerPage->setDefault($_REQUEST["elemperpage"]);

$oSelectSortBy = new cHTMLSelectElement("sortby");
$oSelectSortBy->autoFill($aSortByOptions);
$oSelectSortBy->setDefault($_REQUEST["sortby"]);

$oSelectSortOrder = new cHTMLSelectElement("sortorder");
$oSelectSortOrder->autoFill($aSortOrderOptions);
$oSelectSortOrder->setDefault($_REQUEST["sortorder"]);

$oTextboxFilter = new cHTMLTextbox("filter", $_REQUEST["filter"], 20);

$oSubmit = new cHTMLButton("submit", i18n("Apply"));

$content = '<div style="border-bottom: 1px solid black; background: '.$cfg['color']['table_dark'].';">';
$content .= '<form onsubmit="append_registered_parameters(this);" id="filter" name="filter" method="get" action="main.php?1">';
$content .= '<table>';
$content .= '<input type="hidden" name="area" value="'.$area.'">';
$content .= '<input type="hidden" name="frame" value="'.$frame.'">';
$content .= '<input type="hidden" name="contenido" value="'.$sess->id.'">';
$content .= '<tr>';
$content .= '<td>'. i18n("Items / page").'</td>';
$content .= '<td>'.$oSelectItemsPerPage->render().'</td>';
$content .= '</tr>';
$content .= '<tr>';
$content .= '<td>'. i18n("Sort by").'</td>';
$content .= '<td>'.$oSelectSortBy->render().'</td>';
$content .= '</tr>';
$content .= '<tr>';
$content .= '<td>'. i18n("Sort order").'</td>';
$content .= '<td>'.$oSelectSortOrder->render().'</td>';
$content .= '</tr>';
$content .= '<tr>';
$content .= '<td>'. i18n("Search for").'</td>';
$content .= '<td>'.$oTextboxFilter->render().'</td>';
$content .= '</tr>';
$content .= '<tr>';
$content .= '<td>&nbsp;</td>';
$content .= '<td>'.$oSubmit->render().'</td>';
$content .= '</tr>';
$content .= '</table>';
$content .= '</form>';
$content .= '</div>';
$oListOptionRow->setContentData($content);

$cApiUserCollection = new cApiUserCollection;



if (isset($_REQUEST["sortby"]) && $_REQUEST["sortby"] != "")
{
	$cApiUserCollection->setOrder($_REQUEST["sortby"]. " ". $_REQUEST["sortorder"]);	
} else {
	$cApiUserCollection->setOrder("username asc");
}

if (isset($_REQUEST["filter"]) && $_REQUEST["filter"] != "")
{
	$cApiUserCollection->setWhereGroup("default", "username", "%".$_REQUEST["filter"]."%", "LIKE");	
	$cApiUserCollection->setWhereGroup("default", "realname", "%".$_REQUEST["filter"]."%", "LIKE");
	$cApiUserCollection->setWhereGroup("default", "email", "%".$_REQUEST["filter"]."%", "LIKE");
	$cApiUserCollection->setWhereGroup("default", "telephone", "%".$_REQUEST["filter"]."%", "LIKE");
	$cApiUserCollection->setWhereGroup("default", "address_street", "%".$_REQUEST["filter"]."%", "LIKE");
	$cApiUserCollection->setWhereGroup("default", "address_zip", "%".$_REQUEST["filter"]."%", "LIKE");
	$cApiUserCollection->setWhereGroup("default", "address_city", "%".$_REQUEST["filter"]."%", "LIKE");
	$cApiUserCollection->setWhereGroup("default", "address_country", "%".$_REQUEST["filter"]."%", "LIKE");
	
	$cApiUserCollection->setInnerGroupCondition("default", "OR");
}
$cApiUserCollection->query();

$users = new Users();

$mlist = new UI_Menu;


$aCurrentUserPermissions = split(",", $auth->auth["perm"]);
$aCurrentUserAccessibleClients = $classclient->getAccessibleClients();

$iMenu = 0;
$iItemCount = 0;
$mPage = $_REQUEST["page"];

if ($mPage == 0)
{
	$mPage = 1;	
}

$elemperpage = $_REQUEST["elemperpage"];

if ($elemperpage == 0)
{
	$elemperpage = 25;
}

while ($cApiUser = $cApiUserCollection->next())
{
	$userid = $cApiUser->get("user_id");
	
	$aUserPermissions = split(",", $cApiUser->get("perms"));
	
	$bDisplayUser = false;

    if (in_array("sysadmin", $aCurrentUserPermissions))
    {
        $bDisplayUser = true;
    }
    
    foreach ($aCurrentUserAccessibleClients as $key => $value)
    {
        if (in_array("client[$key]", $aUserPermissions))
        {
            $bDisplayUser = true;
        }
    }
    
    foreach ($aUserPermissions as $sLocalPermission)
    {
        
        if (in_array($sLocalPermission, $aCurrentUserPermissions))
        {
            $bDisplayUser = true;
        }
    }    
    
    $link = new cHTMLLink;
    $link->setMultiLink("user", "", "user_overview", "");
    $link->setCustom("userid", $cApiUser->get("user_id"));
    
    if ($bDisplayUser == true)
    {
    	$iItemCount++;

    	if ($iItemCount > ($elemperpage * ($mPage - 1)) && $iItemCount < (($elemperpage * $mPage) + 1))
    	{
	        if ($perm->have_perm_area_action('user',"user_delete") ) { 
	        		$message = sprintf(i18n("Do you really want to delete the user %s?"), $username);
	        		

					$delTitle = i18n("Delete user");
					$deletebutton = '<a title="'.$delTitle.'" href="javascript://" onclick="box.confirm(\''.$delTitle.'\', \''.$message.'\', \'deleteBackenduser(\\\''.$userid.'\\\')\')"><img src="'.$cfg['path']['images'].'delete.gif" border="0" title="'.$delTitle.'" alt="'.$delTitle.'"></a>';
				        		
	            } else {
	                $deletebutton = "";
	            }
	
	
	    	$iMenu++;
	    	$mlist->setTitle($iMenu, $cApiUser->get("username")."<br>".$cApiUser->get("realname"));
	    	$mlist->setLink($iMenu, $link);		
	    	$mlist->setActions($iMenu, "delete", $deletebutton); 
	    	$mlist->setImage($iMenu, "images/users.gif");
    	}
    }
	
}

$oPagerLink = new cHTMLLink;
$oPagerLink->setLink("main.php");
$oPagerLink->setCustom("elemperpage", $elemperpage);
$oPagerLink->setCustom("filter", $_REQUEST["filter"]);
$oPagerLink->setCustom("sortby", $_REQUEST["sortby"]);
$oPagerLink->setCustom("sortorder", $_REQUEST["sortorder"]);
$oPagerLink->setCustom("frame", $frame);
$oPagerLink->setCustom("area", $area);
$oPagerLink->enableAutomaticParameterAppend();
$oPagerLink->setCustom("contenido", $sess->id);

$oPager = new cObjectPager("44b41691-0dd4-443c-a594-66a8164e25fd", $iItemCount, $elemperpage, $mPage, $oPagerLink, "page");


                                   
$deleteScript = '    <script type="text/javascript">

        /* Session-ID */
        var sid = "'.$sess->id.'";

        /* Create messageBox
           instance */
        box = new messageBox("", "", "", 0, 0);

        /* Function for deleting
           modules */

        function deleteBackenduser(userid) {

			form = document.getElementById("filter");

            url  = \'main.php?area=user_overview\';
            url += \'&action=user_delete\';
            url += \'&frame=4\';
            url += \'&userid=\' + userid;
            url += \'&contenido=\' + sid;
            url += get_registered_parameters();
            url += \'&sortby=\' +form.sortby.value;
			url += \'&sortorder=\' +form.sortorder.value;
			url += \'&filter=\' +form.filter.value;
			url += \'&elemperpage=\' +form.elemperpage.value;
			url += \'&page=\' +\''.$mPage.'\';
			parent.parent.right.right_bottom.location.href = url;
			parent.parent.right.right_top.location.href = \'main.php?area=user&frame=3&contenido=\'+sid;

        }

    </script>';
    
$oPage->setMargin(0);
$oPage->addScript('cfoldingrow.js', '<script language="JavaScript" src="scripts/cfoldingrow.js"></script>');
$oPage->addScript('parameterCollector.js', '<script language="JavaScript" src="scripts/parameterCollector.js"></script>');
$oPage->addScript('messagebox', '<script type="text/javascript" src="scripts/messageBox.js.php?contenido='.$sess->id.'"></script>');
$oPage->addScript('delete', $deleteScript);
$oPage->setContent(array('<table border="0" cellspacing="0" cellpadding="0" width="100%">',$oListOptionRow, $oPager, '</table>', $mlist->render(false)));

$oPage->render();

?>
