<?php
cInclude('classes', 'contenido/class.client.php');

/**
 * Multi Domain hack
 * 
 * resolves additional frontend_paths and check if
 * current host defined as additional frontendpath 
 * if true, use new frontendpath for base tag
 * if false, use default client html path for base path 
 *
 * usage:
 * in client settings you can insert one or more 
 * domain settings like client property "Web Address"
 * type: client
 * name: frontend_path[n] 
 * value: http://www.domain.de/cms/
 * 
 * @param string $strCurrentBaseHref
 * @return string base href string
 * @author stefan seifarth <info@polycoder.de>
 */
function cecFrontendMultiDomainSwitch( $strCurrentBaseHref = "") {
	global $client;
	
	// get all client settings - from all clients!
	$oClient = new cApiClient($client);
   $arrSettings = $oClient->getProperties();
   
	if (isset($arrSettings) && is_array($arrSettings)) {
		foreach ($arrSettings as $arrClient) {
			if ( $arrClient["type"] == "client" && strstr($arrClient["name"],"frontend_path") !== false ) {
				$arrUrlSettings = parse_url($arrClient["value"]);

				if ($arrUrlSettings["host"] == $_SERVER['HTTP_HOST'] || ("www." . $arrUrlSettings["host"] ) == $_SERVER['HTTP_HOST'] || $arrUrlSettings["host"]  ==  "www." . $_SERVER['HTTP_HOST'] ) {
					$strCurrentBaseHref = $arrClient["value"];
					break;
				}
			}
		}
   }
      
   unset($oClient, $arrSettings, $arrClient, $arrUrlSettings);
   
   return $strCurrentBaseHref;
}
?>